<!--
# Experiment

What started as an experiment to work with the A1 catalog parser output,
tried to figure the A3 maker functions on the structure directly with
a small set lu id split-exercise-lu

## Insight

the makers functions are constructor classes to help build models.
Obviously what will be represented in frontend will be a page model,
which will contain this screen models from the maker functions

* cite: maker functions are A3.makeBroker, MakeObject, makeBlock....

### Comment:
leaving this here for now, and trying to refine the page model,
for consistent frontend performance.
date: 22-04-2018
author: salus sage
 -->

<!DOCTYPE html>
<html>
<head>
	<!--script type="text/javascript" src="https://unpkg.com/rxjs@6.1.0/bundles/rxjs.umd.min.js"></script-->
	<meta charset="UTF-8" />
	<script type="text/javascript" src="A1-catalog.js"></script>
	<script type="text/javascript" src="underscore.js"></script>

	<!-- layout styles -->
	<style>
	body, header, aside, footer {
		clear:both;
		float:none;
	}
	article {
		display: block;
		float:right;
		width:80%;
	}
	nav {
		float:left;
	}
	</style>

</head>
<body>
	<header>
		<nav id="table-of-content">
			<h2> Table of Contents </h2>
		</nav>
	</header>
	
	<article id="article-screen">
		<section class="screen" id="split-exercise-lu">
		</section>
	</article>

	<aside>
		<p>This is aside</aside>
	</aside>

	<footer>
		<p>This is a Footer</p>
	</footer>
	

<script type="text/javascript" src="a3-pipeline-alpha.1.js"></script>

<script type="text/javascript">
	document.onload = (function (_){
		//A3 = window.A3 || {};
		console.log("document loaded", CatalogA1, A3);
		window.onhashchange = function(){
			console.log(window.location);
			window.pageFactory(window.location.hash.split('#')[1]);
		}
		window.pageFactory = function(path){
			//Assuming one learning unit is a page
			//var path = "split-exercise-lu";
			//resolve the path with make broker
			var catObject = new A3.makeObject(new A3.makeBroker(CatalogA1, path));
			console.log(catObject, "type:", catObject.getType().toString(), "type will be lu for path", path);
			// tasks and artefacts needs to be resolved
			// will end up with nested objects
			//[TODO]: Handle types - if(catObject.getType.toString() == "lu"){}
				catObject.content.tasks = catObject.getTasks().map(function(task){
					return new A3.makeObject(new A3.makeBroker(CatalogA1, task));
				});

				//console.log(catObject.content.tasks[0], catObject.getTasks());
				catObject.content.tasks[0].content.artifacts = catObject.getTasks().map(function(task){
						console.log(task);
						if(task.hasArtifacts()){
							return task.getArtifacts().map(function(task){
								return new A3.makeObject(new A3.makeBroker(CatalogA1, task));
							});
						} else {
							return null;
						}
					
					})[0];
				console.log("resolved array of tasks and artifacts");
				//options can have layout and styles {layout: {}, styles:{}}
			window.page = function (path, content, options){
				this.path = path;
				this.type = "page";
				this.title = content.getHeading();
				this.content = content;
				this.layout = options.layout;
				this.styles = [];
				this.init = function(){
					//wiring
					this.makeBlocks();
					this.makeDocFragments();
					this.tocFrags = this.tocTemplate(CatalogA1);
					console.log(this.tocFrags);
					this.nav = document.getElementById("table-of-content");
					this.nav.innerHTML = "";
					this.nav.appendChild(this.tocFrags);
					this.layoutTemplate(this.fragments, this);
				}
			}
			page.prototype = {
				getTitle: function(){
					return this.title();
				},
				setBlocks: function(arg){
					this.blocks = arg;
					return this.blocks;
				},
				setFragments: function(arg){
					this.fragments = arg;
					return this.fragments;
				},
				makeBlocks: function(){
					var task =this.content.content.tasks[0];
					var taskBlocks;
					if(task.hasArtifacts()){
						taskBlocks = this.content.content.tasks[0].getArtifacts().map(function(item){
							 return new A3.makeBlock(item, {}).init();
							});
					} else {
						taskBlocks = null;
					}
					
					this.setBlocks(taskBlocks);
				},
				layoutTemplate: function(content, ctx){
					var content = content || [];
						var section = document.getElementsByTagName('section')[0];
						section.innerHTML = "testing";

						var fragment = document.createDocumentFragment();
						var container  = document.createElement('div');
						container.className = "container";
						container.style.clear = ctx.layout.container.clear;
						var left = document.createElement('div');
						left.className = "pane";
						left.style.cssFloat = ctx.layout.left.float;
						left.style.maxWidth = ctx.layout.block.width;
						var right = document.createElement('div');
						right.className = "pane";
						right.style.maxWidth = ctx.layout.block.width;
						right.style.cssFloat = ctx.layout.right.float;
						if(content.length >= 3){
							left.append(content[0][0], content[0][1], content[1][0]);
							right.append(content[2][0], content[2][1], content[3][0]);
						}
						
						container.append(left, right);
						fragment.appendChild(container);
						
						section.appendChild(fragment);

				},
				fragmentTemplate: function(content){
					var fragment = document.createDocumentFragment();
					var element  = document.createElement(content.el);
					element.id = content.id || "";
					element.textContent = content.content;
					fragment.appendChild(element);
					//console.log(fragment, "i am a fragment");
					return fragment;
				},

				makeDocFragments: function(){
					var self=this;
					var docFragments;
					if(this.blocks){
						docFragments = this.blocks.map(function(block){ 
						return block.map(function(item){ 
							return self.fragmentTemplate(item);
							});
						});
					} else {
						docFragments = null;
					}
					
				
				this.setFragments(docFragments);

				},
				updateDOM: function(){
					this.layoutTemplate(this.fragments, this);
				},
				getTableofContents: function(catalog){
					//to get all type lu from the catalog
					return _.compact(_.allKeys(catalog).map(function(cat){ 
						return new A3.makeObject(A3.makeBroker(CatalogA1, cat)); 
					}).map(function(obj){ 
						if(obj.getType() === 'lu'){ 
							return obj;
						}
					}));
				},
				tocTemplate: function(arg){
					var tocs = this.getTableofContents(arg);
					var fragment = document.createDocumentFragment();
					var ul  = document.createElement('ul');

					_.each(tocs, function(toc){
						var li = document.createElement('li');
						var atag = document.createElement('a');
						atag.href = "#" + toc.getId();
						atag.innerText = toc.getHeading();
						li.appendChild(atag);
						ul.appendChild(li);
					});
					
					return fragment.appendChild(ul);
				}

			}

				//define schema for two column layout
				var twoColumnLayout = {
					block: {
						width:"50%"
					}, 
					left: {
						float: "left"
					},
					right: {
						float: "right"
					},
					container: {
						clear: "both"
					}
				}
				window.thisPage = new page(path, catObject, {
					layout: twoColumnLayout
				});
				console.log(thisPage, "new page model");
				thisPage.init();

		}
		


		
	})(_);
</script>

</body>
</html>
